Subject: bug#71290: Options for viewing project buffers

From: mikpom <[email-masked]>
Date: Sat, 01 Jun 2024 23:07:17 +0700

Thanks for pointing to ibuffer-project. It will deliver on my request
even if suggested feature is never implemented.

On Sat, 2024-06-01 at 18:27 +0300, Dmitry Gutov wrote:
> Hi!
> 
> On 31/05/2024 15:28, mikpom wrote:
> > Greetings devs and emacs community.
> > 
> > I occasionally need to list buffers of a project and do so with the
> > built-in command project-list-buffers from project.el. The problem
> > is
> > that this command utilizes Buffer-menu mode and does so in a hard-
> > coded
> > way. Personally I prefer IBuffer which is already heavily
> > customized
> > while I have zero knowledge of Buffer-menu mode.
> > 
> > I suggest to make an option whether project.el will list buffers
> > with
> > Ibuffer, Buffer-menu or even something else?
> 
> I'm happy to add a new option, but if you look at the definition of 
> project-list-buffers, it's not as trivial as
> 
>   - bind default-directory
>   - call function
> 
> And ibuffer seems to require some effort as well. As a consequence,
> the 
> option is unlikely to be infinitely extensible, it would just list 
> 'list-buffers' and 'ibuffers' as possible values. Maybe a "Custom 
> function" alternative too, but the users who would want to use it
> will 
> need to put it some work as well.
> 
> Speaking of ibuffer in particular, here's a hint of setup required to
> use it for project buffers: 
> https://github.com/emacsmirror/ibuffer-project/blob/master/ibuffer-project.el
> 
> Of course, a lot of this could be optional (improvements to make the
> UI 
> better), so if someone wanted to contribute a minimal implementation,
> we 
> could certainly use it (just please don't copy the code from the
> above, 
> it's not copyright-assigned).